<?php
/**
 * PercorreContabilizacao.
 *
 * @package Logic
 *
 * @author  alessandrobartels
 *
 */
class PercorreContabilizacao{

    private $_nrorg;
    private $_nrOrgPadrao;
    private $_nrEstruturaTrab;
    private $_nrTpModalidadeCalc;
    private $_nrOcorrenciaCalc;
    private $_mes_competencia;
    private $_tipo_movimento;
    private $_nr_tipo_hierarquia;
    private $_simulacao;
    private $_retrocesso;
    private $_dsOrdem;
    private $_dsInicio;
    private $_dsFim;
    private $_vinculom;
    private $_hierarquia_org;
    private $_tipo_hierarquia;
    private $_movimentacao;
    private $_calculo_folha;
 //   private $_resumoContabil;
    private $_formulario;


    /**
     * Construtor da classe.
     *
     * @param integer    $nrorg            Numero da Organizacao.
     * @param TkDateTime $mes_competencia  Data de competencia.
     * @param string     $tp_processamento Tipo de processamento.
     * @param integer    $tp_movimento     Tipo de movimento.
     * @param integer    $nr_hierarq_org   Numero do tipo de hierarquia da Organizacao.
     * @param Parametros $parametro        Instancia de Parametros.
     * @param string     $dsOrdem          Parametro de ordenacao.
     *
     * @author alessandrobartels
     *         alessandrobartels - 20/12/2011 - Implementacao do $parametro.
     */
    public function __construct($tp_processamento, $nrFormulario, Parametros $parametro){

        $this->_nrorg = $parametro->getNrOrgTrabalho();
        $this->_nrOrgPadrao = $parametro->getNrOrgPadrao();
        $this->_nrEstruturaTrab = \FPA::getEstruturaTrabalho();
//        $this->_nrEstruturaTrab = $parametro->getNrEstrutTrab();
        $this->_mes_competencia = $parametro->getMesCompetencia();

        $this->_nrTpModalidadeCalc = $parametro->getTipoModalidadeCalculo();
        $this->_nrOcorrenciaCalc = $parametro->getNrOcorrenciaCalculo();

        $this->_buscaDadosFormulario($nrFormulario);
//        $this->_nrorg = $nrorg;
//        $this->_nrOrgPadrao = $nrOrgPadrao;
//        $this->_nr_tipo_hierarquia = $nr_hierarq_org;
//        $this->_tipo_movimento = $tp_movimento;
//        $this->_mes_competencia =  new TkDateTime($mes_competencia, TkDateTime::FORMAT_DATE);
//        $this->_dsOrdem = $dsOrdem;

        // @todo Verificar
        /* Tipo processamento */
        $tp_processamento = strtoupper($tp_processamento);
        switch ($tp_processamento){
        case Parametros::PROC_SIMULACAO :
            $this->_simulacao = true;
            $this->_retrocesso = false;
            break;
        case Parametros::PROC_CALCULO :
            $this->_simulacao = false;
            $this->_retrocesso = false;
            break;
        case Parametros::PROC_RETROCESSO :
            $this->_retrocesso = true; break;
        default:
            tk_message('Tipo de processo '.$tp_processamento.' invalido', 'warning');
        }

        $this->_tipo_hierarquia = new TipohierarqorgEntity();
        $this->_hierarquia_org = new HierarquiaorgEntity();
        $this->_vinculom = new GpevinculomEntity();
        $this->_calculo_folha = new FpacalculofolhaEntity();
     //   $this->_resumoContabil = new FparesumoctblEntity();

    }


    /**
     * Percorre os vinculos executando o processo de contabilizacao.
     *
     * @throws Exception $e.
     *
     * @return void
     *
     * @author alessandrobartels
     *         alessandrobartels - 20/12/2011 - Implementacao do tipo de modalidade e nr ocorrencia de calculo.
     */
    public function percorre(){

        $demonstrativo = new DemonstrativoContabilizacao($this->_mes_competencia->toString(TkDateTime::FORMAT_DATE));

        $calculo_folha = $this->_calculo_folha->retornaCalculoFolha(
            $this->_nrorg, $this->_tipo_movimento, $this->_mes_competencia, $this->_nrTpModalidadeCalc,
            $this->_nrOcorrenciaCalc
        );

        foreach ($calculo_folha as $calc_folha) {
            $lista_calculo_folha[] = $calc_folha->getNrcalculofolha();
        }

        $contabiliza = new Contabilizacao($this->_nrorg, $this->_nrOrgPadrao, $this->_mes_competencia, $this->_simulacao, $this->_formulario);
        $tipo_hierarquia = $this->_tipo_hierarquia->retornaTipoHierarquia($this->_nrOrgPadrao, $this->_nrorg, $this->_nr_tipo_hierarquia);
        /* Validar retorno de tipo de tipo hierarquia*/

       $hierarquias = $this->_hierarquia_org->retornaHierarquiaPorTipo($this->_nrorg, $this->_nr_tipo_hierarquia);
        /* Validar retorno de hierarquia*/

        $vinculos = $this->_vinculom->retornaVinculosAtivosMesCompetencia(
            $this->_nrorg, $this->_mes_competencia, $this->_dsInicio, $this->_dsFim, $this->_dsOrdem, true,
            $this->_nrEstruturaTrab
        );


//        $contabiliza->setTotalizaEventos(array());
        foreach ($vinculos as $vinculo) {
            /*@todo Verificar retrocesso. Nao existe parametro no formulario. */
            if ($this->_retrocesso === false) {
                try {

                    /* $elementoDemonstrativo = $demonstrativo->addElemento($vinculo->getNrvinculom(), $contador); */
                    /*$result_parcial = $contabiliza->contabilizar(
                        $vinculo, $lista_calculo_folha, $tipo_hierarquia->getNrtipoestrutrel(), $hierarquias,
                        $demonstrativo
                    );*/
                    $result_parcial = $contabiliza->contabilizar($vinculo, $lista_calculo_folha, $demonstrativo);
                } catch(Exception $e) {
                    throw $e;
                }
            } else {
                $contabiliza->retrocedeResumoEventos($vinculo, $tipo_hierarquia->getNrtipoestrutrel(), $hierarquias);
            }
        }
// Pega a instancia e a lista de resumos contabeis
      /*  $resumo = $contabiliza->getResumoContabil();
        $itens = $resumo->getItems();*/

        // 

    //    $totalEventos = $contabiliza->getTotalizaEventos();
    //    $demonstrativo->addEventoContabilizacao($totalEventos);

        // Imprime a contabilizacao
        $demonstrativo = $contabiliza->preparaDemonstrativo($demonstrativo);
        //$demonstrativo->montaEventoContabilizacao();
        return $demonstrativo;
    }


    private function _buscaDadosFormulario($nrFormulario){
        $formulario = new FpaFormcontabilEntity();
        $this->_formulario = $formulario->retornaDadosFormulario($this->_nrorg, $nrFormulario);
        $this->_dsOrdem = $this->_formulario->getDsordem();
        $this->_dsInicio = $this->_formulario->getDsinicio();
        $this->_dsFim = $this->_formulario->getDsfim();
        $this->_nr_tipo_hierarquia = $this->_formulario->getNrhierarqorg();
        $this->_tipo_movimento = $this->_formulario->getNrtipomoviment();

    }
}