/* Procedure para incluso da NF referente ao financeiro */
create or replace PROCEDURE INCLUI_NOTA(
   P_IDENTRSAIDOP IN NOTAFISCAL.IDENTRSAIDOP%TYPE,
   P_CDEMPRESA    IN NOTAFISCAL.CDEMPRESA%TYPE,
   P_CDINSCESTA   IN NOTAFISCAL.CDINSCESTA%TYPE,
   P_CDINSCMUNI   IN NOTAFISCAL.CDINSCMUNI%TYPE,
   P_CDFILIAL     IN NOTAFISCAL.CDFILIAL%TYPE,
   P_LANCAMENTO   IN NOTAFISCAL.NRLANCTONF%TYPE,
   P_CDFILRECEMI  IN NOTAFISCAL.CDFILIRECE%TYPE,
   P_VALORDOC     IN NOTAFISCAL.VRNOTAFISC%TYPE,
   P_TIPOOPER     IN NOTAFISCAL.CDTIPOOPER%TYPE,
   P_IDORIGDEST   IN NOTAFISCAL.IDORIGDESTNF%TYPE,
   P_CDCLIEFORN   IN VARCHAR2,
   P_NRNOTAFISC   IN NOTAFISCAL.NRNOTAFISC%TYPE,
   P_CDSERIE      IN NOTAFISCAL.CDSERIE%TYPE,
   P_DTEMISSAO    IN NOTAFISCAL.DTEMISSAO%TYPE,
   P_DTENTRSAID   IN NOTAFISCAL.DTENTRSAID%TYPE,
   P_LINCENUSO    IN NOTAFISCAL.NRLICENCAUSO%TYPE,
   P_CDVENDEDOR   IN NOTAFISCAL.CDVENDEDOR%TYPE,
   P_CDDESPESA    IN NOTAFISCAL.CDAUTDESPESA%TYPE,
   P_STATUS       IN NOTAFISCAL.IDSTATUS%TYPE,
   P_DTLANCNF     IN DATE)
AS
   V_IDTPIJUR VARCHAR2(1);
   V_NRINSJUR VARCHAR2(20);
BEGIN
   IF P_IDORIGDEST = 'F' THEN
      /* SE A ORIGEM FOR FORNECEDOR*/
      BEGIN
         SELECT IDTPIJURFORN, NRINSJURFORN
         INTO V_IDTPIJUR, V_NRINSJUR
         FROM FORNECEDOR
         WHERE CDFORNECED = P_CDCLIEFORN;
      EXCEPTION
      WHEN NO_DATA_FOUND THEN V_IDTPIJUR := '';
                              V_NRINSJUR := '';
      END;
   ELSIF P_IDORIGDEST = 'C' THEN
      /*SE A ORIGEM FOR CLIENTE*/
      BEGIN
         SELECT IDTPIJURCLIE, NRINSJURCLIE
         INTO V_IDTPIJUR, V_NRINSJUR
         FROM CLIENTE
         WHERE CDCLIENTE = P_CDCLIEFORN;
      EXCEPTION
      WHEN NO_DATA_FOUND THEN V_IDTPIJUR := '';
                              V_NRINSJUR := '';
      END;
   ELSIF P_IDORIGDEST = 'L' THEN
      /*SE A ORIGEM FOR FILIAL*/
      BEGIN
         SELECT IDTPIJURFILI, NRINSJURFILI
         INTO V_IDTPIJUR, V_NRINSJUR
         FROM FILIAL
         WHERE CDFILIAL = P_CDFILRECEMI;
      EXCEPTION
      WHEN NO_DATA_FOUND THEN V_IDTPIJUR := '';
                              V_NRINSJUR := '';
      END;
   END IF;

   IF P_IDENTRSAIDOP = 'E' THEN
      INSERT INTO NOTAFISCAL
         (CDFILIAL, NRLANCTONF, CDEMPRESA, CDINSCESTA, CDINSCMUNI, CDFILIRECE,
          IDTPIJURNF, NRINSJURNF, CDFORNECED, IDBLOQUEADO, IDDOCFISCAL, IDDOCFINANC,
          VRPRODUTOS, VRNOTAFISC, NRNOTAFISC, DTEMISSAO,DTENTRSAID, IDENTRSAIDOP,
          CDTIPOOPER, CDSERIEENTR, IDDOCCONTAB, IDSTATUS, IDSISTEMA, CDAUTDESPESA, DTLANCAMENNF)
      VALUES
         (P_CDFILIAL, P_LANCAMENTO, P_CDEMPRESA, P_CDINSCESTA, P_CDINSCMUNI, P_CDFILRECEMI,
          V_IDTPIJUR, V_NRINSJUR, P_CDCLIEFORN, 'S', 'N', 'S', P_VALORDOC, P_VALORDOC,
          P_NRNOTAFISC, P_DTEMISSAO, P_DTENTRSAID, 'E', P_TIPOOPER, P_CDSERIE, 'S',
          P_STATUS, 'PDV', P_CDDESPESA, P_DTLANCNF);
   ELSE

      INSERT INTO NOTAFISCAL
        (CDFILIAL, NRLANCTONF, CDEMPRESA, CDINSCESTA, CDINSCMUNI, CDFILIEMIT,
         IDTPIJURNF, NRINSJURNF, CDCLIENTE, IDBLOQUEADO, IDDOCFISCAL, IDDOCFINANC,
         VRPRODUTOS, VRNOTAFISC, NRNOTAFISC, DTEMISSAO, DTENTRSAID, IDENTRSAIDOP,
         CDTIPOOPER, CDSERIE, IDDOCCONTAB, IDSTATUS, IDDOCFISCENT,
         IDDOCFISCSAI, IDDOCESTOQUE, IDSISTEMA, NRLICENCAUSO, CDVENDEDOR,DTLANCAMENNF)
      VALUES
        (P_CDFILIAL, P_LANCAMENTO, P_CDEMPRESA, P_CDINSCESTA, P_CDINSCMUNI, P_CDFILRECEMI,
         V_IDTPIJUR, V_NRINSJUR, P_CDCLIEFORN, 'S', 'N', 'S',  
         P_VALORDOC, P_VALORDOC, P_NRNOTAFISC, P_DTEMISSAO, P_DTENTRSAID, 'S',
         P_TIPOOPER, P_CDSERIE, 'S', P_STATUS, 'N', 
         'S', 'N', 'PDV', P_LINCENUSO, P_CDVENDEDOR, P_DTLANCNF);
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('INCLUI_NOTA','5.01.016'); END;
/

